<template>
  <ObModal
    ref="modal"
    :title="`Поставщики – участники сценария «${ scenario.title }»`"
    :is-show-controls="true"
    :is-confirm="true"
    :is-submit-disabled="isOptionsDisabled"
    cancel-text="Отменить"
    size="max"
    @submit="close"
    @cancel="cancelChanges"
  >
    <ObInput
      v-model="searchQuery"
      placeholder="Например, название компании, ИНН, город"
      class="search-field"
      icon="search"
    />

    <ObTable
      ref="filter-contractors-table"
      :columns="filterContractorsColumns"
      :remote-opt="{
        method: getPostedOffersCarriers,
        arguments: {
          tenderUuid,
          scenarioUuid
        },
        contentKey: 'carriers'
      }"
      :functional-panel="true"
      :search-query="searchQuery"
      :table-layout-fixed="true"
      :is-functional-sort="false"
      :is-functional-filter="false"
      :is-functional-group="false"
      :is-functional-search="false"
      :with-checkboxes="!isOptionsDisabled"
      :checked-rows="checkedRows"
      class="participants-table"
      @row-toggle="onCheckboxToggle"
    >
      <template slot="extraFuncButtons">
        <div class="filter-header">
          Выбрано:

          <div class="filter-calculated">
            <template v-if="scenarioParams.CONTRACTOR_FILTER.length">
              {{ contractorsCount - scenarioParams.CONTRACTOR_FILTER.length }}

              <span class="filter-excluded">
                Исключено из распределения: {{ scenarioParams.CONTRACTOR_FILTER.length }}
              </span>
            </template>

            <template v-else>
              все ({{ contractorsCount }})
            </template>
          </div>
        </div>
      </template>
    </ObTable>
  </ObModal>
</template>

<script>
  import ObTable from "common-components/src/obComponents/obTable";
  import ObInput from "common-components/src/obComponents/obInput";
  import ScenarioModalMixin from "../mixins/scenarioModalMixin";
  import { mapGetters } from "vuex";
  import api from "@/api";

  export default {
    name: "tender-scenario-contractors-modal",
    mixins: [
      ScenarioModalMixin
    ],
    components: {
      ObTable,
      ObInput
    },
    data () {
      return {
        carriers: [],
        searchQuery: null,
        filterContractorsColumns: [
          {
            title: "Название контрагента",
            key: "title"
          },
          {
            title: "ИНН",
            key: "inn"
          }
        ],
        initialCheckedRows: []
      }
    },
    computed: {
      ...mapGetters({
        scenario: "tendersScenario/scenario",
        scenarioParams: "tendersScenario/scenarioParams",
        isOptionsDisabled: "tendersScenario/isOptionsDisabled",
        contractorsCount: "tendersScenario/contractorsCount"
      }),
      scenarioParams: {
        get () {
          return this.$store.state.tendersScenario.scenario.params
        },
        set (value) {
          this.$store.dispatch("tendersScenario/setParams", value)
        }
      },
      checkedRows () {
        return this.carriers.filter(({ uuid }) => !this.scenarioParams.CONTRACTOR_FILTER.includes(uuid)).map(({ uuid }) => uuid)
      }
    },
    methods: {
      open() {
        this.initialCheckedRows = this.scenarioParams.CONTRACTOR_FILTER;

        this.$refs.modal.open();
      },
      async getPostedOffersCarriers({ tenderUuid, scenarioUuid, ...args }) {
        const response = await api.tendersScenarios.getTenderScenarioPostedOffersCarriers({ tenderUuid, scenarioUuid, ...args });

        this.carriers = response.carriers;

        return response;
      },
      onCheckboxToggle(item, selectedUuids) {
        this.scenarioParams.CONTRACTOR_FILTER = this.carriers.filter(({ uuid }) => !selectedUuids.includes(uuid)).map(({ uuid }) => uuid);
      },
      cancelChanges() {
        this.scenarioParams.CONTRACTOR_FILTER = this.initialCheckedRows;
      }
    }
  }
</script>

<style lang="scss" scoped>
  @import "~common-components/src/static/css/mixins";

  .search-field {
    margin-bottom: 10px;

    &::v-deep .icon {
      color: $color-grey-span;
    }
  }

  .participants-table {
    border: 1px solid $lavender;
  }

  .filter-header {
    @include font-mixin(16px, 20px, 400, $color-text-base);

    padding: 0 9px;
    display: flex;
    align-items: flex-start;
    justify-content: flex-start;
  }

  .filter-calculated {
    margin-left: 5px;

    span {
      margin-left: 15px;
      color: $color-error;
    }
  }
  
  .filter-excluded {
    color: $color-error;
  }
</style>